// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rosgraph_monitor_msgs:msg/TopicStatistic.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rosgraph_monitor_msgs/msg/topic_statistic.hpp"


#ifndef ROSGRAPH_MONITOR_MSGS__MSG__DETAIL__TOPIC_STATISTIC__STRUCT_HPP_
#define ROSGRAPH_MONITOR_MSGS__MSG__DETAIL__TOPIC_STATISTIC__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'mean'
// Member 'min'
// Member 'max'
#include "builtin_interfaces/msg/detail/duration__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rosgraph_monitor_msgs__msg__TopicStatistic __attribute__((deprecated))
#else
# define DEPRECATED__rosgraph_monitor_msgs__msg__TopicStatistic __declspec(deprecated)
#endif

namespace rosgraph_monitor_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct TopicStatistic_
{
  using Type = TopicStatistic_<ContainerAllocator>;

  explicit TopicStatistic_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : mean(_init),
    min(_init),
    max(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->statistic_type = 0;
      this->node_name = "";
      this->topic_name = "";
      this->window_count = 0l;
    }
  }

  explicit TopicStatistic_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : node_name(_alloc),
    topic_name(_alloc),
    mean(_alloc, _init),
    min(_alloc, _init),
    max(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->statistic_type = 0;
      this->node_name = "";
      this->topic_name = "";
      this->window_count = 0l;
    }
  }

  // field types and members
  using _statistic_type_type =
    uint8_t;
  _statistic_type_type statistic_type;
  using _node_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _node_name_type node_name;
  using _topic_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _topic_name_type topic_name;
  using _window_count_type =
    int32_t;
  _window_count_type window_count;
  using _mean_type =
    builtin_interfaces::msg::Duration_<ContainerAllocator>;
  _mean_type mean;
  using _min_type =
    builtin_interfaces::msg::Duration_<ContainerAllocator>;
  _min_type min;
  using _max_type =
    builtin_interfaces::msg::Duration_<ContainerAllocator>;
  _max_type max;

  // setters for named parameter idiom
  Type & set__statistic_type(
    const uint8_t & _arg)
  {
    this->statistic_type = _arg;
    return *this;
  }
  Type & set__node_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->node_name = _arg;
    return *this;
  }
  Type & set__topic_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->topic_name = _arg;
    return *this;
  }
  Type & set__window_count(
    const int32_t & _arg)
  {
    this->window_count = _arg;
    return *this;
  }
  Type & set__mean(
    const builtin_interfaces::msg::Duration_<ContainerAllocator> & _arg)
  {
    this->mean = _arg;
    return *this;
  }
  Type & set__min(
    const builtin_interfaces::msg::Duration_<ContainerAllocator> & _arg)
  {
    this->min = _arg;
    return *this;
  }
  Type & set__max(
    const builtin_interfaces::msg::Duration_<ContainerAllocator> & _arg)
  {
    this->max = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t PUBLISHED_PERIOD =
    0u;
  static constexpr uint8_t RECEIVED_PERIOD =
    1u;
  static constexpr uint8_t TAKE_AGE =
    2u;

  // pointer types
  using RawPtr =
    rosgraph_monitor_msgs::msg::TopicStatistic_<ContainerAllocator> *;
  using ConstRawPtr =
    const rosgraph_monitor_msgs::msg::TopicStatistic_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rosgraph_monitor_msgs::msg::TopicStatistic_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rosgraph_monitor_msgs::msg::TopicStatistic_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rosgraph_monitor_msgs::msg::TopicStatistic_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rosgraph_monitor_msgs::msg::TopicStatistic_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rosgraph_monitor_msgs::msg::TopicStatistic_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rosgraph_monitor_msgs::msg::TopicStatistic_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rosgraph_monitor_msgs::msg::TopicStatistic_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rosgraph_monitor_msgs::msg::TopicStatistic_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rosgraph_monitor_msgs__msg__TopicStatistic
    std::shared_ptr<rosgraph_monitor_msgs::msg::TopicStatistic_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rosgraph_monitor_msgs__msg__TopicStatistic
    std::shared_ptr<rosgraph_monitor_msgs::msg::TopicStatistic_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TopicStatistic_ & other) const
  {
    if (this->statistic_type != other.statistic_type) {
      return false;
    }
    if (this->node_name != other.node_name) {
      return false;
    }
    if (this->topic_name != other.topic_name) {
      return false;
    }
    if (this->window_count != other.window_count) {
      return false;
    }
    if (this->mean != other.mean) {
      return false;
    }
    if (this->min != other.min) {
      return false;
    }
    if (this->max != other.max) {
      return false;
    }
    return true;
  }
  bool operator!=(const TopicStatistic_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TopicStatistic_

// alias to use template instance with default allocator
using TopicStatistic =
  rosgraph_monitor_msgs::msg::TopicStatistic_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t TopicStatistic_<ContainerAllocator>::PUBLISHED_PERIOD;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t TopicStatistic_<ContainerAllocator>::RECEIVED_PERIOD;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t TopicStatistic_<ContainerAllocator>::TAKE_AGE;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace rosgraph_monitor_msgs

#endif  // ROSGRAPH_MONITOR_MSGS__MSG__DETAIL__TOPIC_STATISTIC__STRUCT_HPP_
