// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rosgraph_monitor_msgs:msg/TopicStatistics.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rosgraph_monitor_msgs/msg/topic_statistics.hpp"


#ifndef ROSGRAPH_MONITOR_MSGS__MSG__DETAIL__TOPIC_STATISTICS__STRUCT_HPP_
#define ROSGRAPH_MONITOR_MSGS__MSG__DETAIL__TOPIC_STATISTICS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"
// Member 'statistics'
#include "rosgraph_monitor_msgs/msg/detail/topic_statistic__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rosgraph_monitor_msgs__msg__TopicStatistics __attribute__((deprecated))
#else
# define DEPRECATED__rosgraph_monitor_msgs__msg__TopicStatistics __declspec(deprecated)
#endif

namespace rosgraph_monitor_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct TopicStatistics_
{
  using Type = TopicStatistics_<ContainerAllocator>;

  explicit TopicStatistics_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : timestamp(_init)
  {
    (void)_init;
  }

  explicit TopicStatistics_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : timestamp(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _timestamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _timestamp_type timestamp;
  using _statistics_type =
    std::vector<rosgraph_monitor_msgs::msg::TopicStatistic_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rosgraph_monitor_msgs::msg::TopicStatistic_<ContainerAllocator>>>;
  _statistics_type statistics;

  // setters for named parameter idiom
  Type & set__timestamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->timestamp = _arg;
    return *this;
  }
  Type & set__statistics(
    const std::vector<rosgraph_monitor_msgs::msg::TopicStatistic_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rosgraph_monitor_msgs::msg::TopicStatistic_<ContainerAllocator>>> & _arg)
  {
    this->statistics = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rosgraph_monitor_msgs::msg::TopicStatistics_<ContainerAllocator> *;
  using ConstRawPtr =
    const rosgraph_monitor_msgs::msg::TopicStatistics_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rosgraph_monitor_msgs::msg::TopicStatistics_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rosgraph_monitor_msgs::msg::TopicStatistics_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rosgraph_monitor_msgs::msg::TopicStatistics_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rosgraph_monitor_msgs::msg::TopicStatistics_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rosgraph_monitor_msgs::msg::TopicStatistics_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rosgraph_monitor_msgs::msg::TopicStatistics_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rosgraph_monitor_msgs::msg::TopicStatistics_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rosgraph_monitor_msgs::msg::TopicStatistics_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rosgraph_monitor_msgs__msg__TopicStatistics
    std::shared_ptr<rosgraph_monitor_msgs::msg::TopicStatistics_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rosgraph_monitor_msgs__msg__TopicStatistics
    std::shared_ptr<rosgraph_monitor_msgs::msg::TopicStatistics_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TopicStatistics_ & other) const
  {
    if (this->timestamp != other.timestamp) {
      return false;
    }
    if (this->statistics != other.statistics) {
      return false;
    }
    return true;
  }
  bool operator!=(const TopicStatistics_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TopicStatistics_

// alias to use template instance with default allocator
using TopicStatistics =
  rosgraph_monitor_msgs::msg::TopicStatistics_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rosgraph_monitor_msgs

#endif  // ROSGRAPH_MONITOR_MSGS__MSG__DETAIL__TOPIC_STATISTICS__STRUCT_HPP_
